#ifndef VDENGINE_H
#define VDENGINE_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include "VDMapEditor.h"
#include "VDNPCEditor.h"
#include "VDDirect3D.h"
#include "VDInput.h"
#include "VDWorld.h"
#include "VDEntity.h"
#include "VDNPC.h"
#include "Resource.h"



/* **********************************************************************************************************************
   Global Constants
   **********************************************************************************************************************/

#define VD_ENGINE_CLASS_NAME "VDEngine"
#define VD_MAP_EDITOR_CLASS_NAME "VDMapEditor"
#define VD_NPC_EDITOR_CLASS_NAME "VDNPCEditor"




/* **********************************************************************************************************************
   VDMapMaker
   **********************************************************************************************************************/

class VDEngine {
public:
    VDEngine();
    virtual ~VDEngine();

    void Run(HINSTANCE instance);
    void RegisterWindows(HINSTANCE instance);
    HWND CreateVDEngineWindow(HINSTANCE instance, LPCSTR className, int width, int height);
    void VDOpenFile(HWND window, LPSTR filter, LPSTR fileName);
    void AddNPC(LPCSTR name, LPCSTR imageFileLocation);
    void RemoveNPC(LPCSTR name);
    void AddNPCDialogue(LPCSTR npcName, int id, LPCSTR text);
    void RemoveNPCDialogue(LPCSTR name, int id);
    void AddNPCDialogueOption(LPCSTR name, int dialogueID, LPCSTR text, int nextID);
    void RemoveNPCDialogueOption(LPCSTR npcName, int dialogueID, LPCSTR optionName);
    void WriteNPCs();
    void LoadNPCs();

           VDNPC GetNPC(LPCSTR name);
          LPCSTR GetNPCDialogue(LPCSTR name, int index);
    unsigned int GetNPCDialogueID(LPCSTR npcName, int index);
          LPCSTR GetNPCDialogueOption(LPCSTR npcName, int dialogueID, int optionIndex);
    unsigned int GetNPCDialogueOptionNextID(LPCSTR npcName, int dialogueID, int optionIndex);
private:
            int mapMakerRunning;
    list<VDNPC> npcs;
};



#endif  // VDENGINE_H