#ifndef VDMAPEDITOR_H
#define VDMAPEDITOR_H



/* **********************************************************************************************************************
   Included Header Files
   **********************************************************************************************************************/

#include <windows.h>
#include "VDSprite.h"
#include "VDError.h"
#include "Resource.h"



/* **********************************************************************************************************************
   VDMapEditor
   **********************************************************************************************************************/

class VDMapEditor {
public:
    VDMapEditor();
    ~VDMapEditor();

    HWND CreateMapEditor(HINSTANCE instance, HWND parentWindow, LPCSTR className);

         HWND GetWindow();
         HWND GetMapNameEditBox();
         HWND GetSaveMapButton();
         HWND GetLoadMapButton();
         HWND GetClearMapButton();
         HWND GetLoadSpriteButton();
    VDSprite* GetTileSprite();
         void SetTileSprite(VDSprite *newSprite);
       LPCSTR GetTileSpriteLocation();
         void SetTileSpriteLocation(LPCSTR spriteLocation);
       LPRECT GetTileSpriteDimensions(LPRECT outRect);
         HWND GetTileSpawnsListBox();
         HWND GetCreaturesListBox();
         HWND GetRemoveSpawnButton();
         HWND GetAddSpawnButton();
         HWND GetNullTileOption();
         HWND GetOpenTileOption();
         HWND GetImpassableTileOption();
         HWND GetNewAreaTileOption();
         HWND GetLoadNewAreaButton();
         HWND GetNewAreaStatic();
       LPCSTR GetNewAreaLocation();
         void SetNewAreaLocation(LPCSTR aNewAreaLocation);
         HWND GetNewAreaStartingPointX();
         HWND GetNewAreaStartingPointY();
         HWND GetNPCListBox();
    VDSprite* GetNPCSprite();
         void SetNPCSprite(VDSprite *newSprite);
       LPCSTR GetNPCSpriteLocation();
         void SetNPCSpriteLocation(LPCSTR spriteLocation);
       LPRECT GetNPCSpriteDimensions(LPRECT outRect);
         HWND GetNullNPCOption();
         HWND GetNormalNPCOption();
         HWND GetStaticNPCOption();
private:
         HWND window;
         HWND mapNameEditBox;
         HWND saveMapButton;
         HWND loadMapButton;
         HWND clearMapButton;
         HWND loadSpriteButton;
    VDSprite* tileSprite;
         char tileSpriteLocation[FILE_NAME_MAX_SIZE];
         RECT tileSpriteDimensions;
         HWND tileSpawnsListBox;
         HWND creaturesListBox;
         HWND removeSpawnButton;
         HWND addSpawnButton;
         HWND nullTileOption;
         HWND openTileOption;
         HWND impassableTileOption;
         HWND newAreaTileOption;
         HWND loadNewAreaButton;
         HWND newAreaStatic;
         char newAreaLocation[FILE_NAME_MAX_SIZE];
         HWND newAreaStartingPointX;
         HWND newAreaStartingPointY;
         HWND npcsListBox;
    VDSprite* npcSprite;
         char npcSpriteLocation[FILE_NAME_MAX_SIZE];
         RECT npcSpriteDimensions;
         HWND nullNPCOption;
         HWND normalNPCOption;
         HWND staticNPCOption;
};



#endif  // VDMAPEDITOR_H